/*
 * Enemy1.java
 *
 * Last modified: <2008/09/01 14:37:00 +0900> By SUMIDA
 */
package game;

public class Enemy1 implements EnemyModule {

    public void init(Ship.Info info) {

        Logging.trace("info=" + info + ", id=" + info.id);
        info.sprite.dy = Real.IntToReal(1);
    }

    public void action(Ship.Info info) {

        switch (info.stat) {
        case Ship.SHIP_STAT_APPEAR:
            if (info.count < 0) {
                info.count = 5;
                info.stat = Ship.SHIP_STAT_MOVE;
            }
            break;

        case Ship.SHIP_STAT_MOVE:
            if (info.count < 0) {
                info.count = 5;
                info.stat = Ship.SHIP_STAT_NORMAL;
            }
            break;

        case Ship.SHIP_STAT_NORMAL:
            if (info.count < 0 && SystemInfo.Random(0, 128) < SystemInfo.level) {
                info.count = 5;
                info.stat = Ship.SHIP_STAT_FIRE;
            }
            break;

        case Ship.SHIP_STAT_FIRE:
            if (info.count < 0 && SystemInfo.Random(0, 128) < SystemInfo.level) {
                /* 狙い撃ち単発弾の発射 */
                Shot.Info shot = Shot.getInfo(Enemy.enemy_shot_mgr, Shot.SHOT_ID_BALLET);

                if (shot != null) {
                    Shot.fire(shot, info, 0, 0);
                    Shot.homing(shot, MyShip.ship, Real.IntToReal(1));
                }

                info.count = 5;
                info.stat = Ship.SHIP_STAT_MOVE;
            }
            break;

        default:
            return;
        }

        /* 画面端で反転 */
        if (info.sprite.dx < 0 && info.sprite.x < Real.IntToReal(10)
            || info.sprite.dx > 0 && info.sprite.x > Real.IntToReal(SystemInfo.WIDTH - 10)) {
            info.sprite.dx = -info.sprite.dx;
        }
    }

    public void term(Ship.Info info) {
        Logging.trace("info=" + info);
    }
}
