/*
 * Enemy2.java
 *
 * Last modified: <2008/09/01 14:36:52 +0900> By SUMIDA
 */
package game;

public class Enemy2 implements EnemyModule {

    public void init(Ship.Info info) {

        Logging.trace("info=" + info + ", id=" + info.id);
        info.sprite.dy = Real.IntToReal(2);
    }

    public void action(Ship.Info info) {

        switch (info.stat) {
        case Ship.SHIP_STAT_APPEAR:
            /* 画面端で反転 */
            if (info.sprite.dx < 0 && info.sprite.x < Real.IntToReal(10)
                || info.sprite.dx > 0 && info.sprite.x > Real.IntToReal(SystemInfo.WIDTH - 10)) {
                info.sprite.dx = -info.sprite.dx;
            }

            if (info.count < 0) {
                info.count = 60;
                info.stat = Ship.SHIP_STAT_MOVE;
            }
            break;

        case Ship.SHIP_STAT_MOVE:
            if (info.count < 0) {

                /* 急速反転 */
                Sprite.setAngle(
                    info.sprite,
                    Sprite.getAngle(info.sprite, MyShip.ship.sprite) - 180,
                    Real.IntToReal(4));

                info.count = 0;
                info.stat = Ship.SHIP_STAT_NORMAL;
            }
            break;

        case Ship.SHIP_STAT_NORMAL:
            if (SystemInfo.Random(0, 128) < SystemInfo.level) {
                info.count = 10;
                info.stat = Ship.SHIP_STAT_FIRE;
            }
            break;

        case Ship.SHIP_STAT_FIRE:
            if (info.count < 0 && SystemInfo.Random(0, 128) < SystemInfo.level) {
                /* ２連弾の発射 */
                Shot.Info shot1 = Shot.getInfo(Enemy.enemy_shot_mgr, Shot.SHOT_ID_BALLET);
                Shot.Info shot2 = Shot.getInfo(Enemy.enemy_shot_mgr, Shot.SHOT_ID_BALLET);

                if (shot1 != null) {
                    Shot.fire(shot1, info, Real.IntToReal(-6), 0);
                    shot1.sprite.dy = Real.IntToReal(3);
                }

                if (shot2 != null) {
                    Shot.fire(shot2, info, Real.IntToReal(30), 0);
                    shot2.sprite.dy = Real.IntToReal(3);
                }

                info.count = 0;
                info.stat = Ship.SHIP_STAT_NORMAL;
            }
            break;

        default:
            return;
        }
    }

    public void term(Ship.Info info) {
        Logging.trace("info=" + info);
    }
}
