/*
 * Enemy3.java
 *
 * Last modified: <2008/09/01 14:36:41 +0900> By SUMIDA
 */
package game;

public class Enemy3 implements EnemyModule {

    public void init(Ship.Info info) {

        Logging.trace("info=" + info + ", id=" + info.id);
        info.sprite.dy = Real.IntToReal(1)>>1;
    }

    public void action(Ship.Info info) {

        switch (info.stat) {
        case Ship.SHIP_STAT_APPEAR:
            /* 自機側に方向変更 */
            if (info.sprite.x < MyShip.ship.sprite.x && info.sprite.dx < 0
                || info.sprite.x > MyShip.ship.sprite.x && info.sprite.dx > 0) {

                info.sprite.dx = -info.sprite.dx;
            }

            if (info.count < 0) {
                info.count = 5;
                info.stat = Ship.SHIP_STAT_MOVE;
            }
            break;

        case Ship.SHIP_STAT_MOVE:
            if (info.count < 0) {
                info.count = 5;
                info.stat = Ship.SHIP_STAT_NORMAL;
            }
            break;

        case Ship.SHIP_STAT_NORMAL:
            if (info.count < 0 && SystemInfo.Random(0, 128) < SystemInfo.level) {
                info.count = 5;
                info.stat = Ship.SHIP_STAT_FIRE;
            }
            break;

        case Ship.SHIP_STAT_FIRE:
            if (info.count < 0 && SystemInfo.Random(0, 128) < SystemInfo.level) {
                /* レーザーの発射 */
                Shot.Info shot = Shot.getInfo(Enemy.enemy_shot_mgr, Shot.SHOT_ID_RAY1);

                if (shot != null) {
                    Shot.fire(shot, info, 0, 0);
                    shot.sprite.dy = Real.IntToReal(2);
                    Sound.playEffect(Audio.SE_SHOT0);
                }

                info.count = 10;
                info.stat = Ship.SHIP_STAT_MOVE;
            }
            break;

        default:
            return;
        }
    }

    public void term(Ship.Info info) {
        Logging.trace("info=" + info);
    }
}
