/*
 * Missile.java
 *
 * Last modified: <2008/08/29 07:11:46 +0900> By SUMIDA
 */
package game;

public class Missile implements EnemyModule {

    public void init(Ship.Info info) {

        Logging.trace("info=" + info + ", id=" + info.id);
        info.sprite.options |= 15;
        info.sprite.dy = Real.IntToReal(2);
    }

    public void action(Ship.Info info) {

        Surface.Info surface_info = Surface.getInfo(info.sprite.surface_id);
        Surface.Info surface_ship = Surface.getInfo(MyShip.ship.sprite.surface_id);

        info.sprite.dx = 0;

        if (info.sprite.y < MyShip.ship.sprite.y) {
            int x0 = info.sprite.x + (Real.IntToReal(surface_info.frame_width) >> 1);
            int x1 = MyShip.ship.sprite.x + (Real.IntToReal(surface_ship.frame_width) >> 1);

            if (x0 < x1)
                info.sprite.dx = Real.IntToReal(1);
            else if (x0 > x1)
                info.sprite.dx = -Real.IntToReal(1);
        }

        if (info.count < 0) {
            Effect.Info effect = Effect.getInfo(Effect.EFFECT_ID_FIRE);

            if (effect != null) {
                Effect.setPosition(effect, info.sprite, 0, -Real.IntToReal(25));
                effect.sprite.dx = Real.IntToReal((int)SystemInfo.Random(-2, 2));
                effect.sprite.dy = -Real.IntToReal((int)SystemInfo.Random(2, 4));
                info.count = 5;
            }
        }
    }

    public void term(Ship.Info info) {
        Logging.trace("info=" + info);
    }
}
